abstract class OggettoLanciato {
	
  protected int val=1;
  
  abstract void lancio();
  
  public int get(){return val;}
  
  public boolean equals(Object obj){
	if (obj == null) return false;
	if(! (obj instanceof OggettoLanciato)) return false;
	else return (val==((OggettoLanciato)obj).val);
  }
  
  public void print(){ System.out.println(this);}
}// end-abstract-class


class Dado extends OggettoLanciato{
	
  public void lancio(){
	  val=(1+(int)(Math.random()* 6));
  }
  
  public String toString(){return "Dado: " + val;}
  
  public boolean equals(Object obj) {
  	if (obj instanceof Dado) return super.equals(obj);
   	else return false;
  }	
}//end-class-Dado


class Moneta extends OggettoLanciato{
	
  //si assume 1=testa, 0=croce
  public void lancio(){val=(int)(Math.random()* 2);}
  
  public String toString(){if (val==1) return "Moneta: Testa"; else return "Moneta: Croce";}
  
  public boolean equals(Object obj) {
  	if (obj instanceof Moneta) return super.equals(obj);
   	else return false;
  }
}//end-class-Moneta


 